package com.objisformation.jsf2;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Locale;
import java.util.Map;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.ValueChangeEvent;

@ManagedBean(name = "country")
@SessionScoped
public class CountryBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private static Map<String, String> countries;

	// default value
	private String localeCode = "fr";

	static {
		countries = new LinkedHashMap<String, String>();
		countries.put("Angleterre", "en"); // label, value
		countries.put("France", "fr");
		countries.put("Allemagne", "de");
		countries.put("Chine", "zh_CN");
	}

	/**
	 * permet de changer le code local en fonction du choix de la langue
	 * 
	 * @param event
	 * @throws AbortProcessingException
	 */
	public void changeCodeLocalePays(ValueChangeEvent event)
			throws AbortProcessingException {

		FacesContext context = FacesContext.getCurrentInstance();
		System.out.println("Changement de la langue : " + event.getNewValue());
		String langue = (String) event.getNewValue();
		if (countries.containsKey(langue)) {
			String code = countries.get(langue);
			if (code.equals("en")) {
				context.getViewRoot().setLocale(Locale.ENGLISH);
				System.out.println("vous avez slectionnez la langue: "
						+ langue);
			}
			if (code.equals("fr")) {
				context.getViewRoot().setLocale(Locale.FRENCH);
				System.out.println("vous avez slectionnez la langue: "
						+ langue);
			}
			if (code.equals("de")) {
				context.getViewRoot().setLocale(Locale.GERMAN);
				System.out.println("vous avez slectionnez la langue: "
						+ langue);
			}
			if (code.equals("zh_CN")) {
				context.getViewRoot().setLocale(Locale.CHINA);
				System.out.println("vous avez slectionnez la langue: "
						+ langue);
			}

		}

		else {
			context.getViewRoot().setLocale(Locale.ENGLISH);
		}
		// assign new value to localeCode
		localeCode = event.getNewValue().toString();
	}

	public Map<String, String> getCountryInMap() {
		return this.countries;
	}

	public String getLocaleCode() {
		return localeCode;
	}

	public void setLocaleCode(String localeCode) {
		this.localeCode = localeCode;
	}

}